--
-- Sample LUA code for the TIMER_CreateObject function
--

-- Sample 1 - count down from 10
--
-- global routines passed the timer object
-- recurring timer
--
function Arm ( object )
	print ( "Sample 1 - Start with "..object.Count )
	object.Count = object.Count -1
end

function Trigger ( object, other )
	print ( "Sample 1 - Triggered with "..object.Count )
	if (object.Count == 0) then
		object.Cancel()
	else
		object.Count = object.Count -1
	end
	-- the other timer should not have fired yet, re-arm
	other.Arm(7000) -- 7 seconds
end

function Cancel ( object )
	print ( "Sample 1 - Canceled with "..object.Count )
	object.Destroy()
end

Sample1 = TIMER_CreateObject()
Sample1.Create ( "Arm(Sample1)", "Trigger(Sample1, Sample4)", "Cancel(Sample1)", 1 )
Sample1.Count = 10
Sample1.Arm ( 500 ) -- .5 seconds

-- Sample 2 - count up to 20
--
-- timer object and routines are part of a larger object
-- one shot, re-armed in trigger routine
--
Sample2 = { timer = TIMER_CreateObject(),

Arm = function()
	print("Sample 2 - Arm for "..(Sample2.Milliseconds * Sample2.Count).." milliseconds")
end,

Trigger = function ()
	print("Sample 2 - Trigger at "..(Sample2.Milliseconds * Sample2.Count).." milliseconds")
	Sample2.Count = Sample2.Count + 1
	if (Sample2.Count == 20) then
		Sample2.timer.Cancel ( )
	else
		Sample2.timer.Arm ( Sample2.Milliseconds * Sample2.Count )
	end
end,

Cancel = function()
	print("Sample 2 - Cancel")
	Sample2.timer.Destroy ( )
end,

Count = 1,

Milliseconds = 50 -- .05 seconds
}

Sample2.timer.Create ( "Sample2.Arm()", "Sample2.Trigger()", "Sample2.Cancel()", 0 )
Sample2.timer.Arm ( Sample2.Milliseconds * Sample2.Count )

-- Sample 3 - recurring timer used as one shot
--
-- routine added to timer object
-- recurring timer destroyed after a single trigger
--
Sample3 = TIMER_CreateObject()

function Sample3.Trigger()
	print("Sample 3 - Trigger")
	Sample3.Destroy()
end

Sample3.Create(nil,"Sample3.Trigger()","",1)
Sample3.Arm(10000) -- 10 seconds

-- Sample 4 - Trigger
--
-- functions coded in the Create call
-- one shot timer
--
Sample4 = TIMER_CreateObject()
Sample4.Create("TriggerEvent('Sample 4 Armed',18)",
		"TriggerEvent('Sample 4 Triggered',18);Sample4.Cancel()",
		"TriggerEvent('Sample 4 Canceled',18);Sample4.Destroy()",
		0)
Sample4.Arm(7000) -- 7 seconds
